//
//	eyemLibEwb_[
//
#ifndef __EYEM_LIB_H
#define __EYEM_LIB_H

#include <float.h>

/********************************************************************************************/
/*                                     ʃwb_[                                         */
/********************************************************************************************/

// ʒ`
#define FUNC_OK						0						// I
#define FUNC_NOT_ENOUGH_MEM			(-1)					// [Ns
#define FUNC_ILLEGAL_ARGUMENT		(-2)					// sK
#define FUNC_CANNOT_CALC			(-100)					// vZs
#define FUNC_CANNOT_USE				(-999)					// gps

// G[R[hisvZj
#define FUNC_DET_EQ_ZERO			(-110)					// s񎮂[
#define FUNC_FAILED_EIGEN			(-111)					// ŗLlEŗLxNgvZs
#define FUNC_FAILED_SVD				(-112)					// ْlvZs
#define FUNC_FAILED_CHOLESKY		(-113)					// RXL[vZs

// G[R[hiߎvZj
#define FUNC_FAILED_ROBUST			(-130)					// oXg莸s
#define FUNC_FAILED_ELLIPSE			(-131)					// ȉ~ɂȂȂ
#define FUNC_FAILED_ELLIPSOID		(-132)					// ȉ~̂ɂȂȂ
#define FUNC_FAILED_CONE			(-133)					// ʂɂȂȂ

// G[R[hiJLu[Vj
#define FUNC_FAILED_HOMOGRAPHY		(-150)					// zOtB[svZs
#define FUNC_FAILED_CAM_PRM			(-151)					// Jp[^vZs
#define FUNC_FAILED_BUNDLE_ADJ		(-152)					// ohs
#define FUNC_FAILED_UNDISTORT		(-153)					// cݕ␳s


// 萔
#define EPS				1.0e-9								// 
#define DBL_EPS			DBL_EPSILON							// (@BCvV)
#define PI				3.1415926535897932384626433832795	// 
#define PI_DEG			180.0								// (deg)
#define RAD2DEG			(PI_DEG/PI)							// raddegϊ
#define DEG2RAD			(PI/PI_DEG)							// degradϊ
#define TWO_PI			(2.0*PI)							// 2
#define PI_BY_2			(PI/2.0)							// /2


// r
#ifndef MIN
#define MIN( a, b ) ( ((a) < (b)) ? (a) : (b) )
#endif
#ifndef MAX
#define MAX( a, b ) ( ((a) > (b)) ? (a) : (b) )
#endif


#define ON				1
#define OFF				0

#ifndef TRUE
#define TRUE			1
#endif

#ifndef FALSE
#define FALSE			0
#endif

#ifndef NULL
#ifdef __cplusplus
	#define NULL		0
#else
	#define NULL		((void *)0)
#endif
#endif


// 摜E
#ifndef __EYEM_BORDER
#define __EYEM_BORDER
enum{
	EYEM_BORDER_NONE,										// E͂Ȃ
	EYEM_BORDER_REPLICATE,									// ŊOZxl
	EYEM_BORDER_REFLECT,									// fiŊOɑ΂đΏ̂ɃRs[j
	EYEM_BORDER_ZERO										// Zx[Ŗ߂
};
#endif


// 摜
typedef struct {
	unsigned char			*ucpImage;						// 擪AhX
	int						iWidth;							// 摜TCY
	int						iHeight;						// 摜TCY
}	EyemImage;


// ``
typedef struct {
	int						iXs;							// n_()W
	int						iYs;							// n_()W
	int						iWidth;							// TCYij
	int						iHeight;						// TCYij
}	EyemRect;

typedef struct {
	int						iXs;							// n_()W
	int						iYs;							// n_()W
	int						iXe;							// I_(E)W
	int						iYe;							// I_(E)W
}	EyemRect2;


///////////////////////////////////////////////////////////////////////////////
// Define point or parameter on Orthogonal Coordinate System

/////////////////////
// int type
//
typedef struct{
	int						iX;								// wW
	int						iY;								// xW
}	EyemOcsIXY;

typedef struct{
	int						iX;								// wW
	int						iY;								// xW
	int						iZ;								// yW
}	EyemOcsIXYZ;

typedef struct{
	int						iX;								// wW
	int						iY;								// xW
	int						iQ;								// 
}	EyemOcsIXYQ;

typedef struct{
	int						iX;								// wW
	int						iY;								// xW
	int						iR;								// a
}	EyemOcsIXYR;											// ~̕\Ɏgp

typedef struct{
	int						iA;								// a
	int						iB;								// b
	int						iC;								// c
}	EyemOcsIABC;											// (ʌ`)̕\Ɏgp

typedef struct{
	int						iR;								// 
	int						iQ;								// 
}	EyemOcsIRQ;												// (wbZ̕W`)xNg̕\Ɏgp

typedef struct{
	int						iX;								// wW(PʁFf)
	int						iY;								// xW(PʁFf)
	int						iQ;								// X(PʁFrad)
	int						iS;								// XP[
}	EyemOcsIXYQS;


/////////////////////
// float type
//
typedef struct{
	float					fX;								// wW
	float					fY;								// xW
}	EyemOcsFXY;

typedef struct{
	float					fX;								// wW
	float					fY;								// xW
	float					fZ;								// yW
}	EyemOcsFXYZ;

typedef struct{
	float					fX;								// wW
	float					fY;								// xW
	float					fQ;								// 
}	EyemOcsFXYQ;

typedef struct{
	float					fX;								// wW
	float					fY;								// xW
	float					fR;								// a
}	EyemOcsFXYR;											// ~̕\Ɏgp

typedef struct{
	float					fA;								// a
	float					fB;								// b
	float					fC;								// c
}	EyemOcsFABC;											// (ʌ`)̕\Ɏgp

typedef struct{
	float					fR;								// 
	float					fQ;								// 
}	EyemOcsFRQ;												// (wbZ̕W`)xNg̕\Ɏgp

typedef struct{
	float					fX;								// wW(PʁFf)
	float					fY;								// xW(PʁFf)
	float					fQ;								// X(PʁFrad)
	float					fS;								// XP[
}	EyemOcsFXYQS;


/////////////////////
// double type
//
typedef struct{
	double					dX;								// wW
	double					dY;								// xW
}	EyemOcsDXY;

typedef struct{
	double					dX;								// wW
	double					dY;								// xW
	double					dZ;								// yW
}	EyemOcsDXYZ;

typedef struct{
	double					dX;								// wW
	double					dY;								// xW
	double					dQ;								// 
}	EyemOcsDXYQ;

typedef struct{
	double					dX;								// ŜwW
	double					dY;								// ŜxW
	double					dR;								// a
}	EyemOcsDXYR;											// ~̕\Ɏgp

typedef struct{
	double					dA;								// a
	double					dB;								// b
	double					dC;								// c
}	EyemOcsDABC;											// (ʌ`)̕\Ɏgp

typedef struct{
	double					dR;								// 
	double					dQ;								// 
}	EyemOcsDRQ;												// (wbZ̕W`)xNg̕\Ɏgp

typedef struct{
	double					dX;								// wW
	double					dY;								// xW
	double					dQ;								// ]p(PʁFrad)
	double					dS;								// XP[
}	EyemOcsDXYQS;

typedef struct{
	double					dA;								// a
	double					dB;								// b
	double					dC;								// c
	double					dD;								// d
}	EyemOcsDABCD;											// (ʌ`)̕\Ɏgp

typedef struct{
	double					dXo;							// ŜwW
	double					dYo;							// ŜxW
	double					dL;								// a
	double					dS;								// Za
	double					dQ;								// ̌X(PʁFrad)
}	EyemOcsDXYLSQ;											// ȉ~̕\Ɏgp

typedef struct{
	EyemOcsDXYZ				tP;								// ̂P_̍W
	EyemOcsDXYZ				tV;								// ̕xNg
}	EyemOcsDPV;												// Rԓ̒̕\Ɏgp


typedef struct{
	EyemOcsDXYZ				tC;								// ȉ~̂̒S
	EyemOcsDXYZ				tR;								// ̔a(dXF, dYF, dZFZ)
	double					dU;								// ̂wxʂւ̎ˉewƂȂp(PʁFrad)
	double					dV;								// ̂wxʂƂ̂Ȃp(PʁFrad)
	double					dW;								// ܂̉]p(PʁFrad)
}	EyemOcsDCRUVW;											// ȉ~̂̕\Ɏgp


/********************************************************************************************/
/*                             ȉCe\[XŗL̃wb_[                                 */
/********************************************************************************************/

//////////////////////////////////////////////////////////////////////////////////////////////
// wvZ[eBeBieyemMath.cj
//
#ifdef __cplusplus
extern "C" {
#endif

double	eyemMathCalcInnerProduct( int, double [], double [] );
void	eyemMathCalcOuterProduct( double [], double [], double [] );
int		eyemMathCalcAngle( int, double [], double [], double * );
double	eyemMathCalcNorm( int, double [] );
double	eyemMathCalcArgument( double [] );
int		eyemMathNormalization( int, double [] );
int		eyemMathStat( int, double [], double *, double *, double * );
double	eyemMathMedianI( int, int * );
double	eyemMathMedianD( int, double * );
int		eyemMathOtsuThreshold1d( int, double [], double * );
double	eyemMathAreaTriangle( double, double, double, double, double, double );
double	eyemMathSignAreaTriangle( double, double, double, double, double, double );
void	eyemMathRotatePoint( double, double, double, double, double, double *, double * );
void	eyemMathCreateTransParam( int, double, double, double, double, double *, double *, double * );
void	eyemMathTransCoordOfPoint( double, double, double, double, double, double *, double * );
void	eyemMathInvTransCoordOfPoint( double, double, double, double, double, double *, double * );
void	eyemMathComposeCoord( double, double, double, double, double, double, double *, double *, double * );
double	eyemMathInvMatrixOfSyn3X3( double [][3], double [][3] );
void	eyemMathInvCoord( double, double, double, double *, double *, double * );
double  eyemMathGetDistFromPointToPoint( double, double, double, double );
double	eyemMathGetDistFromPointToLine( double, double, double, double, double );
double	eyemMathGetDistAndCrossPointFromPointToLine( double, double, double, double, double, double *, double * );
double	eyemMathGetDistFromPointToCircle( double, double, double, double, double, double *, double * );
int		eyemMathGetDistFromPointToEllipse( double, double, double, double, double, double, double, double *, double *, double * );
int		eyemMathCrossPoint( double, double, double, double, double, double, double *, double * );
void	eyemMathTransAbcToRq( double, double, double, double *, double * );
double	eyemMathCrossAngle( double, double, double, double, double, double );
int		eyemMathGetLineFrom2Points( double, double, double, double, double *, double *, double * );
void	eyemMathGetOrthogonalLineFromLineAndPoint(double, double, double, double, double, double *, double *, double * );
int		eyemMathCheckAngle( double, double, double );
double	eyemMathAddAngle( int, int, double, double );
double	eyemMathPrimeAngle( int, int, double );
double	eyemMathExtremumOfQuadraticCurves(  double, double, double, double * );
double	eyemMathExtremumOfQuadraticSurface(  double, double, double, double, double, double, double *, double * );
double	eyemMathCrossCorrelation( int, double [], double [] );
int		eyemMathAutoCorrelation( int, double [], int, double [] );
double	eyemMathNormCorrelation( int, double [], double [] );
int		eyemMathNormAutoCorrelation( int, double [], int, double [] );
int		eyemMathSearchOf1DWithNormCorrelation( int, double [], int, double [], int *, double * );
int		eyemMathQuadraticRoots( double [], double [] );
int		eyemMathCubicRoots( double [], double [] );
int		eyemMathQuarticRoots( double [], double [] );
double	eyemMathHorner( int, double	[], double );
void	eyemMathTransCoord( double, double, double, double, double, double *, double * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// svZ[eBeBieyemMat.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
double	*eyemMatMallocVector( int );
double	**eyemMatMallocMatrix( int, int );
void	eyemMatFreeVector( double * );
void	eyemMatFreeMatrix( double ** );
void	eyemMatZero( int, int, void * );
void	eyemMatDiagonal( double, int, void * );
void	eyemMatCopy( int, int, void *, void	* );
void	eyemMatAdd( int, int, void *, void *, void * );
void	eyemMatSub( int, int, void *, void *, void * );
void	eyemMatMulScalar( double, int, int, void *, void * );
int		eyemMatMul( int, int, void *, int, int, void *, void * );
int		eyemMatGenMul( double, int, int, void *, int, int, void	*, double, void	*, void	* );
void	eyemMatMulTransposed( int, int, int, void	*, void	* );
int		eyemMatMulTransposed2( int, int, int, void *, int, int, void *, void * );
void	eyemMatTranspose( int, int, void *, void * );
double	eyemMatTrace( int, void	* );
int		eyemMatInvert( int, void *, void * );
int		eyemMatSolveLU( int, void *, double [], double	[] );
int		eyemMatSolveSVD( int, int, void	*, double [], double [] );
int		eyemMatJacobiEigen( int, void *, double [], void * );
int		eyemMatQrEigen( int, void *, double [], void * );
int		eyemMatSVD( int, int, void *, void *, double [], void * );
int		eyemMatCholeskyDecomp( int, void *, void * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// ߎvZioXgjieyemFit.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemFitMean1dim( int, double [], int, double, double * );
int		eyemFitMean2dim( int, EyemOcsDXY [], int, double, EyemOcsDXY * );
int		eyemFitMean3dim( int, EyemOcsDXYZ [], int, double, EyemOcsDXYZ * );
int		eyemFitLine( int, EyemOcsDXY [], int, double, EyemOcsDABC * );
int		eyemFitLineIn3d( int, EyemOcsDXYZ [], int, double, EyemOcsDPV * );
int		eyemFitPlane( int, EyemOcsDXYZ [], int, double, EyemOcsDABCD * );
int		eyemFitCircle( int, EyemOcsDXY [], int, double, EyemOcsDXYR * );
int		eyemFitEllipse( int, EyemOcsDXY [], int, double, EyemOcsDXYLSQ * );
int		eyemFitEllipseC( int , EyemOcsDXY [], int, double, double [] );
int		eyemFitConics( int, EyemOcsDXY [], int, double, double [] );
int		eyemFitParabola( int, EyemOcsDXY [], int, double, EyemOcsDABC * );
int		eyemFitEllipsoid( int, EyemOcsDXYZ [], int, double, EyemOcsDCRUVW * );
int		eyemFitCone( int, EyemOcsDXYZ [], int, double, double [] );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// Q􉽌vZiQLp[jieyemClp2d.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
void	eyemClp2dDistanceTwoPoints( EyemOcsDXY *, EyemOcsDXY *, double * );
void	eyemClp2dCenterTwoPoints( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY * );
int		eyemClp2dLineTwoPoints( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDABC * );
int		eyemClp2dMidperpendicularTwoPoints( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDABC * );
int		eyemClp2dVerticalLinePointAndLine( EyemOcsDXY *, EyemOcsDABC *, EyemOcsDABC * );
void	eyemClp2dLinePointAndSlope( EyemOcsDXY *, double, EyemOcsDABC * );
int		eyemClp2dIntersectionTwoLines( EyemOcsDABC *, EyemOcsDABC *, EyemOcsDXY * );
int		eyemClp2dAngleTwoLines( EyemOcsDABC *, EyemOcsDABC *, double * );
int		eyemClp2dCenterLineOfTwoLines( EyemOcsDABC *, EyemOcsDABC *, EyemOcsDABC * );
int		eyemClp2dDistancePointToLine( EyemOcsDXY *, EyemOcsDABC *, double * );
int		eyemClp2dFootOfPerpendicularToLine( EyemOcsDXY *, EyemOcsDABC *, EyemOcsDXY * );
int		eyemClp2dTranslationOfLine( EyemOcsDABC *, EyemOcsDXY *, EyemOcsDABC * );
void	eyemClp2dAreaTriangle( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY *, double * );
void	eyemClp2dSignAreaTriangle( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY *, double * );
int		eyemClp2dCircleThreePoints( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXYR * );
void	eyemClp2dCircleTwoPoints( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXYR * );
int		eyemClp2dIntersectionLineAndCircle( EyemOcsDABC *, EyemOcsDXYR *, EyemOcsDXY *, EyemOcsDXY * );
int		eyemClp2dTangentPointToCircle( EyemOcsDXY *, EyemOcsDXYR *, EyemOcsDABC *, EyemOcsDXY *, EyemOcsDABC *, EyemOcsDXY * );
int		eyemClp2dClosestToCircle( EyemOcsDXY *, EyemOcsDXYR *, EyemOcsDXY *, double * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// R􉽌vZiRLp[jieyemClp3d.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
void	eyemClp3dDistanceTwoPoints( EyemOcsDXYZ *, EyemOcsDXYZ *, double * );
void	eyemClp3dCenterTwoPoints( EyemOcsDXYZ *, EyemOcsDXYZ *, EyemOcsDXYZ	* );
int		eyemClp3dLineTwoPoints( EyemOcsDXYZ	*, EyemOcsDXYZ *, EyemOcsDPV * );
int		eyemClp3dFootOfPerpendicularToLine( EyemOcsDXYZ *, EyemOcsDPV	*, EyemOcsDXYZ * );
int		eyemClp3dVerticalLinePointAndLine( EyemOcsDXYZ	*, EyemOcsDPV *, EyemOcsDPV	* );
int		eyemClp3dDistancePointToLine( EyemOcsDXYZ *, EyemOcsDPV *, double * );
int		eyemClp3dDistanceTwoLines( EyemOcsDPV *, EyemOcsDPV *, double * );
int		eyemClp3dPlaneThreePoints( EyemOcsDXYZ *, EyemOcsDXYZ *, EyemOcsDXYZ *, EyemOcsDABCD * );
int		eyemClp3dVerticalPlanePointAndVector( EyemOcsDXYZ *, EyemOcsDXYZ *, EyemOcsDABCD * );
int		eyemClp3dVerticalLinePointAndPlane( EyemOcsDXYZ *, EyemOcsDABCD	*, EyemOcsDPV * );
int		eyemClp3dDistancePointToPlane( EyemOcsDXYZ *, EyemOcsDABCD *, double * );
int		eyemClp3dIntersectionLineAndPlane( EyemOcsDPV *, EyemOcsDABCD *, EyemOcsDXYZ * );
int		eyemClp3dAngleLineAndPlane( EyemOcsDPV *, EyemOcsDABCD *, double * );
int		eyemClp3dFootOfPerpendicularToPlane( EyemOcsDXYZ *, EyemOcsDABCD *, EyemOcsDXYZ * );
int		eyemClp3dIntersectionTwoPlanes( EyemOcsDABCD	*, EyemOcsDABCD	*, EyemOcsDPV * );
int		eyemClp3dAngleTwoPlanes( EyemOcsDABCD *, EyemOcsDABCD *, double * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// vZ􉽁ieyemCg.cj
//

// 
enum {
	EYEM_CG_NOT_INTERSECTION,					// ĂȂ
	EYEM_CG_INTERSECTION,						// Ăi݂ɑ܂j
	EYEM_CG_END1_CONTACT_END2,					// P̒[_ƐQ̒[_ڐGivj
	EYEM_CG_END1_CONTACT_SGM2,					// P̒[_Q̒[_ȊOŐڐG
	EYEM_CG_END2_CONTACT_SGM1,					// Q̒[_P̒[_ȊOŐڐG
	EYEM_CG_SEG1_OVERLAP_SGM2					// PƐQdȂiQ꒼ɂꍇj
};


// _ʒu
enum {
	EYEM_CG_OUTER,								// Oɂ
	EYEM_CG_INNER,								// ɂ
	EYEM_CG_BORDER								// Eɂ
};


#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemCgSortByArgument( int n, EyemOcsDXY taSrcPt[], EyemOcsDXY taDstPt[] );
int		eyemCgConvexHull( int, EyemOcsDXY [], int *, EyemOcsDXY [] );
int		eyemCgSmallestEnclosingCircle( int, EyemOcsDXY [], EyemOcsDXY *, double * );
int		eyemCgIntersectionOfTwoSegments( EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY *, int *, EyemOcsDXY * );
int		eyemCgPointInConvexPolygon( int, EyemOcsDXY [], EyemOcsDXY *, int * );
int		eyemCgIntersectionLineAndConvexPolygon( int, EyemOcsDXY [], EyemOcsDABC *, EyemOcsDXY [] );
int		eyemCgIntersectionSegmentAndConvexPolygon( int, EyemOcsDXY [], EyemOcsDXY *, EyemOcsDXY *, EyemOcsDXY [] );
int		eyemCgPointInPolygon( int, EyemOcsDXY [], EyemOcsDXY *, int * );
int		eyemCgAreaOfPolygon( int, EyemOcsDXY [], double * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// QlubúieyemBin.cj
//

// QlubuFF
enum {
	EYEM_BIN_BLACK,								// 
	EYEM_BIN_WHITE								// 
};


// ubủ͌
typedef struct {
	int				iArea;						// ʐ
	double			dCenterX;					// dSW
	double			dCenterY;					// dSW
	int				iXs, iYs, iXe, iYe;			// Oڒ`in_CI_j
	int				iWidth, iHeight;			// Oڒ`iTCY()CTCY()j
	double			dTheta;						// 厲XΊpiradj
}	EyemBinBlob;


#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemBinOtsuThresholdImage( EyemImage *, EyemRect * );
int		eyemBinOtsuThresholdGray( int, double [] );
int		eyemBinOtsuThresholdHistogram( int, unsigned int [] );
int		eyemBinBinaryImage( EyemImage *, EyemRect *, int, EyemImage * );
int		eyemBinDilation( EyemImage *, EyemRect *, int, int, EyemImage * );
int		eyemBinErosion( EyemImage *, EyemRect *, int, int, EyemImage * );
int		eyemBinOpening( EyemImage *, EyemRect *, int, int, EyemImage * );
int		eyemBinClosing( EyemImage *, EyemRect *, int, int, EyemImage * );
int		eyemBinBlob( EyemImage *, EyemRect *, int, int, int, int, EyemBinBlob **, int * );
void	eyemBinFree( EyemBinBlob ** );
int		eyemBinSauvola( EyemImage *, EyemRect *, int, int, double, double, int, EyemImage * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// PGbWoieyemEdge1d.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemEdge1dDiffMax( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, EyemOcsDXY *, double * );
int		eyemEdge1dGenDiffMax( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, EyemOcsDXY *, double * );
int		eyemEdge1dGenNearest( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, EyemOcsDXY *, double * );
int		eyemEdge1dGenNearestC( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, EyemOcsDXY *, double * );
int		eyemEdge1dGenGradMax( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, EyemOcsDXY *, double * );
int		eyemEdge1dManual( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, int [], EyemOcsDXY *, double * );
int		eyemEdge1dManualG( EyemImage *, EyemOcsDXY *, EyemOcsDXY *, int, double [], int, int [], EyemOcsDXY *, double * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// _Q}b`OieyemMatch.cj
//

// 
enum {
	EYEM_MATCH_LSQ,			// ŏ@EXP[Ȃ
	EYEM_MATCH_LSQ_S,		// ŏ@EXP[肠
	EYEM_MATCH_ROBUST,		// oXgEXP[Ȃ
	EYEM_MATCH_ROBUST_S,	// oXgEXP[肠
	EYEM_MATCH_MINMAX,		// ~j}bNX@EXP[Ȃ
	EYEM_MATCH_MINMAX_S		// ~j}bNX@EXP[肠
};


#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemMatchBasic( int, EyemOcsDXY [], EyemOcsDXY [], EyemOcsDXYQ *, int, double, EyemOcsDXYQS * );
int		eyemMatchDelta( EyemOcsDXYQ *, EyemOcsDXYQS *, double *, double *, double *, double * );
int		eyemMatchPoints( int, EyemOcsDXY [], EyemOcsDXY [], EyemOcsDXYQ *, EyemOcsDXYQS *, EyemOcsDXY [], double [] );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// JLu[VieyemCalib.cj
//

// p^[f[^
typedef struct {
	int				iPtnRefN;					// p^[QƓ_̌
	EyemOcsDXY		*tpObjPt;					// p^[QƓ_̎WiPʁFmmj
	EyemOcsDXY		*tpImgPt;					// p^[QƓ_̉摜WiPʁFfj
}	EyemCalibPtn;


// zOtB[s
typedef struct {
	double			daH[3][3];					// zOtB[sH
	double			daInvH[3][3];				// sH̋ts
}	EyemCalibHom;


// J̓p[^iintrinsic parameterj
typedef struct {
	double			daA[3][3];					// p[^s
	double			dFx, dFy;					// œ_~XP[iPʁFfj
	double			dFs;						// œ_~fWiPʁFfj
	double			dUo, dVo;					// 摜SWiPʁFfj
	double			dTheta;						// igpj摜ʌXΊpiPʁFradj
	double			dK1, dK2;					// WAc݌W
	double			daRsv[5];					// \̈
}	EyemCalibInt;


// J̊Op[^iextrinsic parameterj
typedef struct {
	double			daR[3][3];					// ]s
	double			daT[3];						// ixNg
	double			daRdr[3];					// ]xNgihQX̕\j
}	EyemCalibExt;


#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemCalibCalcHomography( int, void *, void *, double, void * );
int		eyemCalibCameraParam( int, EyemCalibPtn [], double, EyemCalibInt *, EyemCalibExt [], double *, int );
int		eyemCalibRodrigues( int, double [3], double [3][3] );
int		eyemCalibNormalizeData( int, int, void *, void *, void *, void * );
int		eyemCalibUnDistortPoint( EyemCalibInt *, double, double, double *, double * );
int		eyemCalibDistortPoint( EyemCalibInt *, double, double, double *, double * );
int		eyemCalibCameraMatrix( EyemCalibInt *, EyemCalibExt *, double [3][4], int );
int		eyemCalibChange3Dto2D( EyemOcsDXYZ *, EyemCalibInt *, EyemCalibExt *, EyemOcsDXY *, int );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// 摜tB^ieyemSmooth.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemSmoothGaussian( EyemImage *, EyemRect *, int, int, EyemImage * );
int		eyemSmoothMedian( EyemImage *, EyemRect *, int, int, EyemImage * );

#ifdef __cplusplus
}
#endif


//////////////////////////////////////////////////////////////////////////////////////////////
// ̑̃c[ieyemMisc.cj
//
#ifdef __cplusplus
extern "C" {
#endif

// vg^Cv
int		eyemMiscChangeRectToRect2( EyemRect *, EyemRect2 * );
int		eyemMiscChangeRect2ToRect( EyemRect2 *, EyemRect * );
double	eyemMiscBilinearGrayLevel( EyemImage *, double, double );
int		eyemMiscPlotPointsOfLine( EyemOcsIXY *, EyemOcsIXY *, EyemOcsIXY [] );
int		eyemMiscExpandBorder( EyemImage *, EyemRect *, int, int, int, EyemImage *, EyemRect *, EyemRect * );

#ifdef __cplusplus
}
#endif


#endif/* __EYEM_LIB_H */
